﻿namespace UltraGridCustomEditorControlIssue
{
    using System;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinEditors;
    using Infragistics.Win.UltraWinGrid;
    public partial class Form1 : Form
    {
        private Random random;
        private UltraControlContainerEditor ultraControlContainerEditor_Double;
        private Infragistics.Win.Appearance disabledCellApp;
        public Form1()
        {
            this.InitializeComponent();
            this.random = new Random();

            this.components = new Container();
            this.ultraControlContainerEditor_Double = new UltraControlContainerEditor(this.components);

            this.disabledCellApp = new Infragistics.Win.Appearance();
            disabledCellApp.ForeColor = Color.Gray;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(), null);
        }

        private object GetData(int rows = 20, int cols = 4)
        {
            DataTable dt = new DataTable();

            for (int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1), typeof(double));
            }

            for (int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach (DataColumn column in dt.Columns)
                {
                    addRow[column] = this.random.Next(10000) / 100d;
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            this.ultraControlContainerEditor_Double.EditingControl = new DoubleEditorInGrid();
            this.ultraControlContainerEditor_Double.RenderingControl = new DoubleEditorInGrid();

            e.Layout.Bands[0].Columns[0].EditorComponent = this.ultraControlContainerEditor_Double;
            e.Layout.Bands[0].Columns[1].EditorComponent = this.ultraControlContainerEditor_Double;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells[1].Activation = Activation.Disabled;
            e.Row.Cells[1].Appearance = this.disabledCellApp;
        }
    }
}
